#include "usb_bsp.h"

// USB弶ʼļ
#include <string.h>
#include "user_init.h"

#ifdef USB_DATA_STRUCT_ALIGNED
    #if defined ( __ICCARM__ )          /* !< IAR Compiler */
        #pragma data_alignment=4
    #endif
#endif
__ALIGN_BEGIN USB_OTG_CORE_HANDLE USB_OTG_dev __ALIGN_END;

// USBʼ
static void USB_Clock_Init(void)
{
    RCC->PCLKCR1 |= 0x1 << 1;   // USBʱ
    
    RCC->PHYCR |= 0x1 << 2;     // VDD15־ѽ
    
    RCC->PHYCR |= 0x1 << 4;     // USB PHYģ鸴λͷ
    RCC->PHYCR |= 0x1 << 0;     // USB BCKģ鸴λͷ
    
    RCC->PHYCR &= ~(0x1 << 3);  // USB PHY
    RCC->PHYCR &= ~(0x1 << 1);  // USB BCK
    
    RCC->PHYBCKCR |= 0x1 << 8;  // PHY48Mʹ
    
    DelayMs(1000);
}

// USBȥʼ
static void USB_Clock_DeInit(void)
{
    RCC->PHYBCKCR &= ~(0x1 << 8);   // PHYر48M
    
    RCC->PHYCR |= 0x1 << 1;     // رUSB BCK
    RCC->PHYCR |= 0x1 << 3;     // رUSB PHY
    RCC->PHYCR &= ~(0x1 << 0);  // USB BCKģ鸴λ
    RCC->PHYCR &= ~(0x1 << 4);  // USB PHYģ鸴λ
    
    RCC->PHYCR &= ~(0x1 << 2);  // VDD15־
    
    RCC->PCLKCR1 &= ~(0x1 << 1);// رUSBʱ
}

// USB
void USB_Soft_Connect(USB_OTG_CORE_HANDLE *pdev)
{
	USB_OTG_DCTL_TypeDef     dctl;
	
	dctl.d32 = USB_OTG_READ_REG32(&pdev->regs.DREGS->DCTL);
	dctl.b.sftdiscon = 0;
	USB_OTG_WRITE_REG32( &pdev->regs.DREGS->DCTL, dctl.d32);
}

// USBϿ
void USB_Soft_Disconnect(USB_OTG_CORE_HANDLE *pdev)
{
	USB_OTG_DCTL_TypeDef     dctl;
	
	dctl.d32 = USB_OTG_READ_REG32(&pdev->regs.DREGS->DCTL);
	dctl.b.sftdiscon = 1;
	USB_OTG_WRITE_REG32( &pdev->regs.DREGS->DCTL, dctl.d32);
}

// ʼUSB(GPIOʱ)
void USB_OTG_BSP_Init(USB_OTG_CORE_HANDLE * pdev)
{
    USB_Clock_Init();
	
	// Init FIFO Debug Read/Write Region
    memset((uint32_t*)0x50020000, 0x400, 0x00);
}

// ʼUSB(GPIOʱ)
void USB_OTG_BSP_DeInit(USB_OTG_CORE_HANDLE * pdev)
{
    USB_Clock_DeInit();
}

// ʹUSBȫж
void USB_OTG_BSP_EnableInterrupt(USB_OTG_CORE_HANDLE * pdev)
{
	NVIC_ClearPendingIRQ(USB_IRQn);
	NVIC_DisableIRQ(USB_IRQn);
	NVIC_SetPriority(USB_IRQn, 2);
	NVIC_EnableIRQ(USB_IRQn);
	
	// 
	USB_Soft_Disconnect(&USB_OTG_dev);
	USB_OTG_BSP_mDelay(1000);
	USB_Soft_Connect(&USB_OTG_dev);
}

void USB_OTG_BSP_DisableInterrupt(USB_OTG_CORE_HANDLE * pdev)
{
	// 
	USB_Soft_Disconnect(&USB_OTG_dev);
    
    NVIC_DisableIRQ(USB_IRQn);
}


// USBusʱ
void USB_OTG_BSP_uDelay(const uint32_t usec)
{
    DelayUs(usec);
}

// USBmsʱ 
void USB_OTG_BSP_mDelay(const uint32_t msec)
{
    USB_OTG_BSP_uDelay(msec * 1000);
}
