#ifndef FLASH_H
#define FLASH_H

#include <stdint.h>
#include <stdbool.h>

// Internal Flashʽӿ

// 192K
#define INTERNAL_FLASH_ADDR_START       0x00010000
#define INTERNAL_FLASH_ADDR_END         0x00040000
#define INTERNAL_FLASH_PAGE_SIZE        512

bool InFlashInit(void);
bool InFlashPageRead(uint32_t address, uint16_t count, uint8_t *data);
bool InFlashPageWrite(uint32_t address, uint16_t count, uint8_t *data);

// Flashͳһдӿ

#define INTERNAL_FLASH  0   // ڲFlash(ʹ64K洢ݣ192K洢ļ)
#define EXTERNAL_FLASH  1   // ⲿFlash(512byteΪλʣдС8)

#define NOR_FLASH   INTERNAL_FLASH

bool FlashInit(void);
bool FlashChipErase(void);

uint32_t FlashUnitSize(void);
uint32_t FlashUnitCount(void);
bool FlashUnitRead(uint32_t unitAddr, uint16_t unitCount, uint8_t *data);
bool FlashUnitWrite(uint32_t unitAddr, uint16_t unitCount, uint8_t *data);

#endif
