#ifndef __HID_CORE_H_
#define __HID_CORE_H_

#include  "usbd_ioreq.h"

extern uint32_t USBD_HID_AltSet;
extern uint32_t USBD_HID_Protocol;
extern uint32_t USBD_HID_IdleState;

#define USB_HID_CONFIG_DESC_SIZ       41
#define USB_HID_DESC_SIZ              9
#define HID_REPORT_DESC_SIZE          33

extern uint8_t USBD_HID_CfgDesc[USB_HID_CONFIG_DESC_SIZ];
extern uint8_t HID_Device_ReportDesc[HID_REPORT_DESC_SIZE];

uint8_t USBD_HID_Init(void *pdev, uint8_t cfgidx);
uint8_t USBD_HID_DeInit(void *pdev, uint8_t cfgidx);
uint8_t USBD_HID_Setup(void *pdev, USB_SETUP_REQ *req);
uint8_t USBD_HID_DataIn(void *pdev, uint8_t epnum);
uint8_t USBD_HID_DataOut(void *pdev, uint8_t epnum);

uint8_t *USBD_HID_GetCfgDesc(uint8_t speed, uint16_t *length);

#define HID_DESCRIPTOR_TYPE           0x21
#define HID_REPORT_DESC               0x22
#define HID_PHYSICAL_DESC             0x23

#define HID_FS_BINTERVAL              0x0A

#define HID_REQ_SET_PROTOCOL          0x0B
#define HID_REQ_GET_PROTOCOL          0x03

#define HID_REQ_SET_IDLE              0x0A
#define HID_REQ_GET_IDLE              0x02

#define HID_REQ_SET_REPORT            0x09
#define HID_REQ_GET_REPORT            0x01

// USB设备类回调结构体
extern USBD_Class_cb_TypeDef  USBD_HID_cb;
    
uint32_t USBD_HID_GetPollingInterval (USB_OTG_CORE_HANDLE *pdev);

USBD_Status USBD_HID_SendReport(USB_OTG_CORE_HANDLE  *pdev, uint8_t ch,
    uint8_t *report, uint16_t len);
USBD_Status USBD_HID_RecvReport(USB_OTG_CORE_HANDLE  *pdev, uint8_t ch,
    uint8_t *report, uint16_t *len);

#endif 
