#ifndef __MSC_CORE_H__
#define __MSC_CORE_H__

#include "usbd_ioreq.h"
#include "msc_bot.h"
#include "msc_scsi.h"
#include "msc_mem.h"

extern uint8_t USBD_MSC_MaxLun;
extern uint8_t USBD_MSC_AltSet;

uint8_t  USBD_MSC_Init(void *pdev, uint8_t cfgidx);
uint8_t  USBD_MSC_DeInit(void *pdev, uint8_t cfgidx);
uint8_t  USBD_MSC_Setup(void *pdev, USB_SETUP_REQ *req);
uint8_t  USBD_MSC_DataIn(void *pdev, uint8_t epnum);
uint8_t  USBD_MSC_DataOut(void *pdev, uint8_t epnum);

#define BOT_GET_MAX_LUN              0xFE
#define BOT_RESET                    0xFF

#define USB_MSC_CONFIG_DESC_SIZ      32

#define MSC_EPIN_SIZE                MSC_MAX_PACKET 
#define MSC_EPOUT_SIZE               MSC_MAX_PACKET 

#define BOT_GET_MAX_LUN              0xFE
#define BOT_RESET                    0xFF

extern USBD_Class_cb_TypeDef  USBD_MSC_cb;

#endif
