#include "usb.h"
#include "user_init.h"
#include "usb_bsp.h"
#include "usb_int.h"
#include "usbd_desc.h"
#include "usbd_usr.h"
#include "msc_core.h"

void USBInit(void)
{
    FL_BSTIM32_InitTypeDef bstim32InitStruct = {0};
    
    // ʼBTIMʱ(ʱ: (APB1Clcok() / 64 * 1000) = 1ms)
    bstim32InitStruct.clockSource = FL_RCC_BSTIM32_CLK_SOURCE_APB1CLK;
    bstim32InitStruct.prescaler = FL_RCC_GetAPB1ClockFreq() / 1000000 - 1;
    bstim32InitStruct.autoReload = 1000 - 1;
    bstim32InitStruct.autoReloadState = ENABLE;
    FL_BSTIM32_Init(BSTIM32, &bstim32InitStruct);
    
    FL_BSTIM32_ClearFlag_Update(BSTIM32);
    FL_BSTIM32_EnableIT_Update(BSTIM32);
    
    NVIC_DisableIRQ(BSTIM_IRQn);
    NVIC_SetPriority(BSTIM_IRQn, 2);
    NVIC_EnableIRQ(BSTIM_IRQn);
    
    // USBʼ
    USBD_Init(&USB_OTG_dev, &USR_desc, &USBD_MSC_cb, &USR_cb);
    
    // ʱ
    FL_BSTIM32_Enable(BSTIM32);
}

void USBDeInit(void)
{
    // USBȥʼ
    USBD_DeInit(&USB_OTG_dev);
    
    // رնʱ
    FL_BSTIM32_Disable(BSTIM32);
}

void BSTIM_IRQHandler(void)
{
    FL_BSTIM32_ClearFlag_Update(BSTIM32);
}

void USB_IRQHandler(void)
{
    USBD_OTG_ISR_Handler(&USB_OTG_dev);
}
