#ifndef RTC_H
#define RTC_H

#include <stdint.h>
#include <stdbool.h>

typedef struct
{
    uint8_t year;
    uint8_t month;
    uint8_t day;
    uint8_t hour;
    uint8_t minute;
    uint8_t second;
    uint8_t week;
}DateTime;

void RtcInit(void);

bool RtcCheck(const uint8_t *dateTime);

bool RtcRead(uint8_t *dateTime);
bool RtcWrite(uint8_t *dateTime);

bool RtcRead_Hex(uint8_t *dateTime);
bool RtcWrite_Hex(uint8_t *dateTime);

bool RtcBCD2HEX(uint8_t *dateTime);
bool RtcHEX2BCD(uint8_t *dateTime);

#endif
