#ifndef FLASH_H
#define FLASH_H

#include <stdint.h>
#include <stdbool.h>

// SPIӿ
#define SPI_SSN_LOW()   FL_SPI_SetSSNPin(SPI2, FL_SPI_SSN_LOW)
#define SPI_SSN_HIGH()  FL_SPI_SetSSNPin(SPI2, FL_SPI_SSN_HIGH)

void SpiInit(void);
uint32_t SpiWriteAndRead(uint32_t data);
void SpiWriteData(uint8_t *data, uint16_t length);
void SpiReadData(uint8_t *data, uint16_t length);

// External Flashӿ
#define EXTERNAL_FLASH_ADDR_START       0x00100000
#define EXTERNAL_FLASH_ADDR_END         0x00200000
#define EXTERNAL_FLASH_PAGE_SIZE        256
#define EXTERNAL_FLASH_SECTOR_SIZE      4096

bool ExFlashInit(void);
uint32_t ExFlashReadID(void);

bool ExFlashChipErase(void);

bool ExFlashSectorErase(uint32_t addr);
bool ExFlashWriteData(uint32_t addr, uint8_t *data, uint16_t length);
bool ExFlashReadData(uint32_t addr, uint8_t *data, uint16_t length);

bool ExFlashSectorWrite(uint32_t sector, uint8_t count, uint8_t *buffer);
bool ExFlashSectorRead(uint32_t sector, uint8_t count, uint8_t *buffer);

bool ExFlashSectorWrite_512B(uint32_t address, uint8_t count, uint8_t *data);
bool ExFlashSectorRead_512B(uint32_t address, uint8_t count, uint8_t *data);

// Internal Flashʽӿ

// 192K
#define INTERNAL_FLASH_ADDR_START       0x00020000
#define INTERNAL_FLASH_ADDR_END         0x00040000
#define INTERNAL_FLASH_PAGE_SIZE        512

bool InFlashInit(void);
bool InFlashPageRead(uint32_t address, uint16_t count, uint8_t *data);
bool InFlashPageWrite(uint32_t address, uint16_t count, uint8_t *data);

// Flashͳһдӿ

#define INTERNAL_FLASH  0   // ڲFlash(ʹ128K洢ݣ128K洢ļ)
#define EXTERNAL_FLASH  1   // ⲿFlash(512byteΪλʣдС8)

#define NOR_FLASH   INTERNAL_FLASH

bool FlashInit(void);
bool FlashChipErase(void);

uint32_t FlashUnitSize(void);
uint32_t FlashUnitCount(void);
bool FlashUnitRead(uint32_t unitAddr, uint16_t unitCount, uint8_t *data);
bool FlashUnitWrite(uint32_t unitAddr, uint16_t unitCount, uint8_t *data);

#endif
