#ifndef GPIO_H
#define GPIO_H

#include <stdint.h>
#include <stdbool.h>

#define LED1_ON()       GPIOB->DO |= (0x1 << 9)       
#define LED1_OFF()      GPIOB->DO &= ~(0x1 << 9)
#define LED1_TOG()      GPIOB->DO ^= (0x1 << 9)

#define LED2_ON()       GPIOB->DO |= (0x1 << 10) 
#define LED2_OFF()      GPIOB->DO &= ~(0x1 << 10)
#define LED2_TOG()      GPIOB->DO ^= (0x1 << 10)

#define KEY1_READ()     (GPIOA->DIN & (0x1 << 10))
#define KEY2_READ()     (GPIOB->DIN & (0x1 << 12))

extern bool key1Wakeup;
extern bool key2Wakeup;

void GpioInit(void);
void GpioDeInit(void);

#endif
