#ifndef FMPDF_H
#define FMPDF_H

#include <stdint.h>
#include <stdbool.h>
#include <string.h>
#include "pdfdef.h"

/**
 * @brief	ȡFMPDF Library汾Ϣ
 * @return	FMPDF Library汾Ϣ
 */
const char *FMPDF_GetVersion(void);

#ifndef WIN32
/**
 * @brief   豸ʼݴ洢ʽӿ
 * @param[in]   *device 洢ʱṹָ
 * @result  ִн
 *  @retval true ִгɹ
 *  @retval false ִʧ
 */
bool FMPDF_Device_Init(FMPDF_Device *device);

/**
 * @brief   豸洢ռʽ
 * @param   *buffer ʽʹõĻռ
 * @param   length ռĴС
 * @result  ִн
 *  @retval true ִгɹ
 *  @retval false ִʧ
 * @note    úִн󣬸ûӦóʹá
 */
bool FMPDF_Device_Format(uint8_t *buffer, uint16_t length);

/**
 * @brief   ȡ̷
 * @param   *name ̷
 * @result  ִн
 *  @retval true ִгɹ
 *  @retval false ִʧ
 */
bool FMPDF_Device_GetLabel(char *name);

/**
 * @brief   ̷
 * @param   *name ̷
 * @result  ִн
 *  @retval true ִгɹ
 *  @retval false ִʧ
 */
bool FMPDF_Device_SetLabel(char *name);

#endif

/**
 * @brief	ָļ
 * @param[in]	*name ָļļ
 * @param[in]	*file ڴ洢ļϢĴ洢ַ
 * @param[in]   size ڴ洢ļϢĿռС
 * @param[in]   mode ļģʽд
 * @return	ִн
 *	@retval	true ִгɹ
 *	@retval false ִʧ
 */
bool FMPDF_Device_FileOpen(char *name, uint8_t *file, uint16_t size, FMPDF_FileMode mode);

/**
 * @brief	رѴļ
 * @return	ִн
 *	@retval	true ִгɹ
 *	@retval false ִʧ
 */
bool FMPDF_Device_FileClose(void);

/**
 * @brief	򿪵ļд
 * @param[in]	*data дָ
 * @param[in]	len дݳ
 * @return	ִн
 *	@retval	true ִгɹ
 *	@retval false ִʧ
 */
bool FMPDF_Device_FileWrite(uint8_t *data, uint16_t len);

/**
 * @brief	Ӵļȡ
 * @param[out]	*data 洢ָ
 * @param[in]	len ȡݳ
 * @return	ִн
 *	@retval	true ִгɹ
 *	@retval false ִʧ
 */
bool FMPDF_Device_FileRead(uint8_t *data, uint16_t len);

/**
 * @brief	趨PDFĵϢ
 * @param[in]	*configInfo ĵʱʹõϢʹĬã
 * @return	ִн
 *	@retval	RESULT_OK ִгɹ
 *	@retval other ִʧ
 */
FMPDF_Result FMPDF_File_Config(FMPDF_ConfigInfo *configInfo);

/**
 * @brief	ָļ
 * @param[in]	*name ָļļ
 * @param[in]	*file ڴ洢ļϢĴ洢ַ
 * @param[in]   size ڴ洢ļϢĿռС
 * @return	ִн
 *	@retval	RESULT_OK ִгɹ
 *	@retval other ִʧ
 */
FMPDF_Result FMPDF_File_Open(char *name, uint8_t *file, uint16_t size);

/**
 * @brief	رѴļ
 * @return	ִн
 *	@retval	RESULT_OK ִгɹ
 *	@retval other ִʧ
 */
FMPDF_Result FMPDF_File_Close(void);

/**
 * @brief	PDFĵ
 * @param[in]	*fileInfo ôļĸϢNULL
 * @param[in]	*passwdInfo ôļĸϢNULL
 * @return	ִн
 *	@retval	RESULT_OK ִгɹ
 *	@retval other ִʧ
 */
FMPDF_Result FMPDF_File_Create(FMPDF_FileInfo *fileInfo, FMPDF_PasswdInfo *passwdInfo);

/**
 * @brief	PDFĵ
 * @return	ִн
 *	@retval	RESULT_OK ִгɹ
 *	@retval other ִʧ
 */
FMPDF_Result FMPDF_File_Save(void);

/**
 * @brief	ȡǰĵҳϢ
 * @param[out]  *used ʹõҳ
 * @param[out]  *blank Ԥɴҳ
 * @return	ִн
 *	@retval	RESULT_OK ִгɹ
 *	@retval other ִʧ
 */
FMPDF_Result FMPDF_File_GetPagesInfo(uint16_t *used, uint16_t *blank);

/**
 * @brief	ǰPDFĵָ
 * @param   fontType 
 * @return	ִн
 *	@retval	RESULT_OK ִгɹ
 *	@retval other ִʧ
 */
FMPDF_Result FMPDF_File_AddFont(FMPDF_FontType fontType);

/**
 * @brief	ڵǰPDFļͼϢ
 * @param[in]	*imageInfo ImageϸϢ
 * @return	ִн
 *	@retval	RESULT_OK ִгɹ
 *	@retval other ִʧ
 */
FMPDF_Result FMPDF_File_AddImage(FMPDF_ImageInfo *imageInfo);

/**
 * @brief	ڵǰPDFļҳ
 * @return	ִн
 *	@retval	RESULT_OK ִгɹ
 *	@retval other ִʧ
 */
FMPDF_Result FMPDF_File_AddPage(void);

/**
 * @brief	ڵǰPDFļб浱ǰҳı༭Ϣ
 * @return	ִн
 *	@retval	RESULT_OK ִгɹ
 *	@retval other ִʧ
 */
FMPDF_Result FMPDF_Page_SaveContext(void);

/**
 * @brief	õǰҳС
 * param[in]	width ҳ
 * param[in]	height ҳ߶
 * @return	ִн
 *	@retval	RESULT_OK ִгɹ
 *	@retval other ִʧ
 */
FMPDF_Result FMPDF_Page_SetHeightAndWidth(uint16_t width, uint16_t height);

/**
 * @brief	ȡǰҳС
 * @param[out]	*width ҳ
 * @param[out]	*height ҳ߶
 * @return	ִн
 *	@retval	RESULT_OK ִгɹ
 *	@retval other ִʧ
 */
FMPDF_Result FMPDF_Page_GetHeightAndWidth(uint16_t *width, uint16_t *height);

/**
 * @brief   õǰҳɫϢ(ˢ)
 * @param[in]   r ԭɫɫ
 * @param[in]   g ԭɫɫ
 * @param[in]   b ԭɫɫ
 * @return	ִн
 *	@retval	RESULT_OK ִгɹ
 *	@retval other ִʧ
 */
FMPDF_Result FMPDF_Page_SetFillRGB(float r, float g, float b);

/**
 * @brief   õǰҳɫϢ()
 * @param[in]   r ԭɫɫ
 * @param[in]   g ԭɫɫ
 * @param[in]   b ԭɫɫ
 * @return  ִн
 *	@retval	RESULT_OK ִгɹ
 *	@retval other ִʧ
 */
FMPDF_Result FMPDF_Page_SetStrokeRGB(float r, float g, float b);

/**
 * @brief   õǰҳͺʹС
 * param[in]    font 
 * param[in]    size С
 * @return	ִн
 *	@retval	RESULT_OK ִгɹ
 *	@retval other ִʧ
 */
FMPDF_Result FMPDF_Page_SetFontAndSize(FMPDF_FontType font, uint8_t size);

/**
 * @brief   õǰҳ߶ο
 * @param[in]   width ߿
 * @return	ִн
 *	@retval	RESULT_OK ִгɹ
 *	@retval other ִʧ
 */
FMPDF_Result FMPDF_Page_SetLineWidth(float width);

/**
 * @brief   õǰҳ߶Ϊ
 * @param[in]   on ʾ߶εس
 * @param[in]   off ߶εس
 * @return	ִн
 *	@retval	RESULT_OK ִгɹ
 *	@retval other ִʧ
 * @note onoffΪ0ʾʵ
 */
FMPDF_Result FMPDF_Page_SetDashedLine(uint16_t on, uint16_t off);

/**
 * @brief   ڵǰҳʼıϢ
 * @return	ִн
 *	@retval	RESULT_OK ִгɹ
 *	@retval other ִʧ
 */
FMPDF_Result FMPDF_Page_TextBegin(void);

/**
 * @brief   ǰҳıϢ
 * @return	ִн
 *	@retval	RESULT_OK ִгɹ
 *	@retval other ִʧ
 */
FMPDF_Result FMPDF_Page_TextEnd(void);

/**
 * @brief   ָıϢƫϢ(ƽֱϵ)
 * @param[in]   x ꣬Ϊҳ
 * @param[in]   y ꣬Ϊҳ߶
 * @return	ִн
 *	@retval	RESULT_OK ִгɹ
 *	@retval other ִʧ
 * @note    ı󣬺걣ֲ
 *          FMPDF_Page_TextBeginĬΪ(0, 0)
 */
FMPDF_Result FMPDF_Page_TextMove(int32_t x, int32_t y);

/**
 * @brief   ָıϢ
 * @param[in]   *text ıַϢ
 * @return	ִн
 *	@retval	RESULT_OK ִгɹ
 *	@retval other ִʧ
 */
FMPDF_Result FMPDF_Page_TextAdd(const char *text);

/**
 * @brief   ָıϢ
 * @param[in]   *data ıַı
 * @param[in]   length ıַݳ    
 * @return	ִн
 *	@retval	RESULT_OK ִгɹ
 *	@retval other ִʧ
*/
FMPDF_Result FMPDF_Page_TextAdd2(const char *data, uint16_t size);

/**
 * @brief   ָıϢ
 * @param[in]   ʽϢ
 * @return	ִн
 *	@retval	RESULT_OK ִгɹ
 *	@retval other ִʧ
*/
FMPDF_Result FMPDF_Page_TextPrintf(const char *format, ...);

/**
 * @brief   趨ǰҳ߶εʼ㣨ƽֱϵ
 * @param[in]   x ꣬Ϊҳ(floatʹ1λС)
 * @param[in]   y ꣬Ϊҳ߶(floatʹ1λС)
 * @return	ִн
 *	@retval	RESULT_OK ִгɹ
 *	@retval other ִʧ
 */
FMPDF_Result FMPDF_Page_LineStart(int32_t x, int32_t y);
FMPDF_Result FMPDF_Page_LineStart2(float x, float y);

/**
 * @brief   趨߶λƵĿ㣨ƽֱϵ
 * @param[in]   x ꣬Ϊҳ(floatʹ1λС)
 * @param[in]   y ꣬Ϊҳ߶(floatʹ1λС)
 * @return	ִн
 *	@retval	RESULT_OK ִгɹ
 *	@retval other ִʧ
 * @note    ҲᱻΪһ߶εʼ꣬ɶεʵֶ߶λ
 */
FMPDF_Result FMPDF_Page_LineMove(int32_t x, int32_t y);
FMPDF_Result FMPDF_Page_LineMove2(float x, float y);

/**
 * @brief   ָ߶
 * @return	ִн
 *	@retval	RESULT_OK ִгɹ
 *	@retval other ִʧ
 * @note    LineStartLineMoveøúʵ߶λ
 */
FMPDF_Result FMPDF_Page_LineStroke(void);

/**
 * @brief   趨ǰҳƱߵʼ㣨ƽֱϵ
 * @param[in]   x ꣬Ϊҳ
 * @param[in]   y ꣬Ϊҳ߶
 * @return	ִн
 *	@retval	RESULT_OK ִгɹ
 *	@retval other ִʧ
 */
FMPDF_Result FMPDF_Page_CurveStart(int32_t x, int32_t y);

/**
 * @brief   趨߻ƵĿ㣨ƽֱϵ
 * @param[in]   x1 ߿Ƶ1꣬Ϊҳ
 * @param[in]   y1 ߿Ƶ1꣬Ϊҳ߶
 * @param[in]   x2 ߿Ƶ2꣬Ϊҳ
 * @param[in]   y2 ߿Ƶ2꣬Ϊҳ߶
 * @param[in]   x3 Ŀ꣬Ϊҳ
 * @param[in]   y3 Ŀ꣬Ϊҳ߶
 * @return	ִн
 *	@retval	RESULT_OK ִгɹ
 *	@retval other ִʧ
 * @note    ĿҲᱻΪһ߶εʼ꣬ɶεʵֶ߶λ
 */
FMPDF_Result FMPDF_Page_CurveMove(int32_t x1, int32_t y1, int32_t x2, int32_t y2,
    int32_t x3, int32_t y3);

/**
 * @brief   趨߻ƵĿ㣨ƽֱϵ
 * @param[in]   x2 ߿Ƶ2꣬Ϊҳ
 * @param[in]   y2 ߿Ƶ2꣬Ϊҳ߶
 * @param[in]   x3 Ŀ꣬Ϊҳ
 * @param[in]   y3 Ŀ꣬Ϊҳ߶
 * @return	ִн
 *	@retval	RESULT_OK ִгɹ
 *	@retval other ִʧ
 * @note    ĿҲᱻΪһ߶εʼ꣬ɶεʵֶ߶λ
 */
FMPDF_Result FMPDF_Page_CurveMove2(int32_t x2, int32_t y2, int32_t x3, int32_t y3);

/**
 * @brief   趨߻ƵĿ㣨ƽֱϵ
 * @param[in]   x1 ߿Ƶ1꣬Ϊҳ
 * @param[in]   y1 ߿Ƶ1꣬Ϊҳ߶
 * @param[in]   x3 Ŀ꣬Ϊҳ
 * @param[in]   y3 Ŀ꣬Ϊҳ߶
 * @return	ִн
 *	@retval	RESULT_OK ִгɹ
 *	@retval other ִʧ
 * @note    ĿҲᱻΪһ߶εʼ꣬ɶεʵֶ߶λ
 */
FMPDF_Result FMPDF_Page_CurveMove3(int32_t x1, int32_t y1, int32_t x3, int32_t y3);

/**
 * @brief   ָ
 * @return	ִн
 *	@retval	RESULT_OK ִгɹ
 *	@retval other ִʧ
 * @note    CurveStartCurveMovexøúʵ߶λ
 */
FMPDF_Result FMPDF_Page_CurveStroke(void);

/**
 * @brief   ڵǰҳַָƾ
 * @param[in]   x ʾλõĺ
 * @param[in]   y ʾλõ
 * @param[in]   width ָƾεĿ
 * @param[in]   height ָƾεĸ߶
 * @return	ִн
 *	@retval	RESULT_OK ִгɹ
 *	@retval other ִʧ
 */
FMPDF_Result FMPDF_Page_DrawRectangle(int32_t x, int32_t y, uint16_t width, uint16_t height);

/**
 * @brief   ڵǰҳַָͼƽֱϵ
 * @param[in]   index ͼţFMPDF_File_AddImage˳1ʼ
 * @param[in]   x ͼʾλõĺ
 * @param[in]   y ͼʾλõ
 * @return	ִн
 *	@retval	RESULT_OK ִгɹ
 *	@retval other ִʧ
 */
FMPDF_Result FMPDF_Page_DrawImage(uint16_t index, int32_t x, int32_t y);

/**
 * @brief   ڵǰҳַָͼƽֱϵ
 * @param[in]   index ͼţFMPDF_File_AddImage˳1ʼ
 * @param[in]   x ͼʾλõĺ
 * @param[in]   y ͼʾλõ
 * @param[in]   w ͼʾص
 * @param[in]   h ͼʾص
 * @return	ִн
 *	@retval	RESULT_OK ִгɹ
 *	@retval other ִʧ
 */
FMPDF_Result FMPDF_Page_DrawImage2(uint16_t index, int32_t x, int32_t y, int32_t w, int32_t h);

#endif
