#ifndef PDFDEF_H
#define PDFDEF_H

#include <stdint.h>
#include <stdbool.h>

#ifndef WIN32
typedef struct
{
    // 洢ʽӿ
	uint32_t (*MemoryUnitSize)(void);
	uint32_t (*MemoryUnitCount)(void);
	bool (*MemoryChipErase)(void);
	bool (*MemoryUnitRead)(uint32_t unitAddr, uint16_t unitCount, uint8_t *data);
	bool (*MemoryUnitWrite)(uint32_t unitAddr, uint16_t unitCount, uint8_t *data);
    
    // RTCʽӿ
    // Hexʽ
    // year(1byte) month(1byte) day(1byte) 
    // hour(1byte) minute(1byte) second(1byte)
    // week(1byte)
	bool (*RtcRead)(uint8_t *dateTime);
}FMPDF_Device;
#endif

typedef enum
{
    WRITE = 0,
    READ = 1,
}FMPDF_FileMode;

typedef enum
{
    RESULT_OK = 0,
    RESULT_OPEN_FILE_FAIL,
    RESULT_INVALID_FILE,
    RESULT_INVALID_PAGE,
    RESULT_INVALID_IMAGE,
    RESULT_INVALID_OBJECT,
    RESULT_INVALID_VALUE,
    RESULT_INVALID_FONT,
    RESULT_ERROR_PAGE_MODE,
    RESULT_ERROR_MEMORY_OVERFLOW,
    RESULT_ERROR_OTHER,
}FMPDF_Result;

typedef enum
{
	// Standard Type1 Fonts(14)
    FONT_COURIER = 0,
    FONT_COURIER_BOLD,
    FONT_COURIER_OBLIQUE,
    FONT_COURIER_BOLDOBLIQUE,
    FONT_HELVETICA,
    FONT_HELVETICA_BOLD,
    FONT_HELVETICA_OBLIQUE,
    FONT_HELVETICA_BOLDOBLIQUE,
    FONT_TIMES_ROMAN,
    FONT_TIMES_BOLD,
    FONT_TIMES_ITALIC,
    FONT_TIMES_BOLDITALIC,
    FONT_SYMBOL,
    FONT_ZAPFDINGBATS,
    // Expand Type0 Fonts
    FONT_CHINESE,   
    FONT_JAPANSES,

    FONT_ARIAL,
}FMPDF_FontType;

typedef enum
{
    IMAGE_RAW_GRAY1B,
    IMAGE_RAW_GRAY8B,
    IMAGE_RAW_RGB24B,
    IMAGE_BMP_GRAY1B,
    IMAGE_BMP_GRAY8B,
    IMAGE_BMP_RGB24B,
    IMAGE_JP2,
    IMAGE_JPG,
}FMPDF_ImageType;

typedef struct
{
    bool compress;
    uint16_t pageHeight;
    uint16_t pageWidth;
}FMPDF_ConfigInfo;

typedef struct
{
	char *title;
	char *author;
	char *subject;
	char *keywords;
	char *creationDateTime;
	char *modifiedDateTime;
    char *creator;
}FMPDF_FileInfo;

typedef enum
{
    PRINT_ENABLE = 0x00000004,
    COPY_ENABLE = 0x00000010,
    ANNOTATIONS_ENABLE = 0x00000020,
    TABLE_FIELD_ENABLE = 0x00000108,
    EXTRACT_ENABLE = 0x00000200,
    ASSEMBLE_ENABLE = 0x00000400,
    DIGITAL_PRINT_ENABLE = 0x00000808,
}FMPDF_Premissions;

typedef struct
{
    char *ownerPassword;
    char *userPassword;
    uint32_t premissions;
}FMPDF_PasswdInfo;

typedef struct
{
	uint32_t addr;
	uint16_t size;
	uint16_t width;
	uint16_t height;
	uint16_t type;
}FMPDF_ImageInfo;

#endif
