#include "pdfutil.h"

FMPDF_Result FMPDF_Draw_String(uint16_t x, uint16_t y, char *str)
{
    FMPDF_Result result;

    result = FMPDF_Page_TextBegin();
    if (result != RESULT_OK)
    {
        return result;
    }
    result = FMPDF_Page_TextMove(x, y);
    if (result != RESULT_OK)
    {
        return result;
    }
    result = FMPDF_Page_TextAdd((const char *)str);
    if (result != RESULT_OK)
    {
        return result;
    }
    result = FMPDF_Page_TextEnd();
    if (result != RESULT_OK)
    {
        return result;
    }

    return RESULT_OK;
}

FMPDF_Result FMPDF_Draw_Point(uint16_t size, uint16_t x, uint16_t y)
{
    FMPDF_Result result;

    result = FMPDF_Page_SetLineWidth(size);
    if (result != RESULT_OK)
    {
        return result;
    }
    result = FMPDF_Page_LineStart(x, y);
    if (result != RESULT_OK)
    {
        return result;
    }
    result = FMPDF_Page_LineMove(x + size, y);
    if (result != RESULT_OK)
    {
        return result;
    }
    result = FMPDF_Page_LineStroke();
    if (result != RESULT_OK)
    {
        return result;
    }

    return RESULT_OK;
}

