#include "gpio.h"
#include "main.h"

bool key1Wakeup = false;
bool key2Wakeup = false;

void GpioInit(void)
{
    // LED: PB9 PB10
    // KEY: PA10 PB12
    
    FL_GPIO_InitTypeDef gpioInitStruct = {0};
    
    // LED
    gpioInitStruct.pin = FL_GPIO_PIN_9 | FL_GPIO_PIN_10;
    gpioInitStruct.mode = FL_GPIO_MODE_OUTPUT;
    gpioInitStruct.outputType = FL_GPIO_OUTPUT_PUSHPULL;
    gpioInitStruct.pull = DISABLE;
    FL_GPIO_Init(GPIOB, &gpioInitStruct);
    
    FL_RCC_SetEXTIClockSource(FL_RCC_EXTI_CLK_SOURCE_LSCLK);
    FL_RCC_EnableGroup1OperationClock(FL_RCC_GROUP1_OPCLK_EXTI);
    
    // 1룬½ش
    gpioInitStruct.pin = FL_GPIO_PIN_10;
    gpioInitStruct.mode = FL_GPIO_MODE_INPUT;
    gpioInitStruct.pull = DISABLE;
    FL_GPIO_Init(GPIOA, &gpioInitStruct);
     
    FL_GPIO_ClearFlag_EXTI(GPIO, FL_GPIO_EXTI_LINE_2);	    // жϱ־
    FL_GPIO_SetExtiLine2(GPIO, FL_GPIO_EXTI_LINE_2_PA10);   // жѡ
    FL_GPIO_EnableDigitalFilter(GPIO, FL_GPIO_EXTI_LINE_2); // EXTI˲
    FL_GPIO_SetTriggerEdge(GPIO, FL_GPIO_EXTI_LINE_2,
        FL_GPIO_EXTI_TRIGGER_EDGE_FALLING);                 // ѡ    

    // 2룬ش
    gpioInitStruct.pin = FL_GPIO_PIN_12;
    gpioInitStruct.mode = FL_GPIO_MODE_INPUT;
    gpioInitStruct.pull = DISABLE;
    FL_GPIO_Init(GPIOB, &gpioInitStruct);
        
    FL_GPIO_ClearFlag_EXTI(GPIO, FL_GPIO_EXTI_LINE_7);	    // жϱ־
    FL_GPIO_SetExtiLine7(GPIO, FL_GPIO_EXTI_LINE_7_PB12);   // жѡ
    FL_GPIO_EnableDigitalFilter(GPIO, FL_GPIO_EXTI_LINE_7); // EXTI˲
    FL_GPIO_SetTriggerEdge(GPIO, FL_GPIO_EXTI_LINE_7,
        FL_GPIO_EXTI_TRIGGER_EDGE_RISING);                  // ѡ    
        
    // NVICж
    NVIC_DisableIRQ(GPIO_IRQn);
    NVIC_SetPriority(GPIO_IRQn, 2);
    NVIC_EnableIRQ(GPIO_IRQn);
}

void GPIO_IRQHandler(void)
{
    if (FL_GPIO_IsActiveFlag_EXTI(GPIO, FL_GPIO_EXTI_LINE_2))
    {
        FL_GPIO_ClearFlag_EXTI(GPIO, FL_GPIO_EXTI_LINE_2);
        key1Wakeup = true;
    }
    
    if (FL_GPIO_IsActiveFlag_EXTI(GPIO, FL_GPIO_EXTI_LINE_7))
    {
        FL_GPIO_ClearFlag_EXTI(GPIO, FL_GPIO_EXTI_LINE_7);
        key2Wakeup = true;
    }
}
