#include "lptim.h"
#include "main.h"

bool timeWakeup = false;

void LpTimInit(uint32_t ms)
{
    FL_LPTIM32_InitTypeDef lptimInitStruct = {0};
    
    FL_LPTIM32_Disable(LPTIM32);
    
    lptimInitStruct.clockSource           = FL_RCC_LPTIM32_CLK_SOURCE_LSCLK;
    lptimInitStruct.prescalerClockSource  = FL_LPTIM32_CLK_SOURCE_INTERNAL;
    lptimInitStruct.prescaler             = FL_LPTIM32_PSC_DIV64;
    lptimInitStruct.autoReload            = ms * 512 / 1000;
    lptimInitStruct.mode                  = FL_LPTIM32_OPERATION_MODE_NORMAL;
    lptimInitStruct.countEdge             = FL_LPTIM32_ETR_COUNT_EDGE_RISING;
    lptimInitStruct.onePulseMode          = FL_LPTIM32_ONE_PULSE_MODE_CONTINUOUS;
    
    FL_LPTIM32_Init(LPTIM32, &lptimInitStruct);
    
    FL_LPTIM32_ClearFlag_Update(LPTIM32);
    FL_LPTIM32_EnableIT_Update(LPTIM32);
    
    NVIC_DisableIRQ(LPTIM_IRQn);
    NVIC_SetPriority(LPTIM_IRQn, 2);
    NVIC_EnableIRQ(LPTIM_IRQn);
    
    FL_LPTIM32_Enable(LPTIM32);
}

void LpTimDeInit(void)
{
    FL_LPTIM32_DisableIT_Update(LPTIM32); 
    NVIC_DisableIRQ(LPTIM_IRQn);
    
    FL_LPTIM32_Disable(LPTIM32);
}

void LPTIM_IRQHandler(void)
{
    if ((FL_LPTIM32_IsEnabledIT_Update(LPTIM32)) &&
        (FL_LPTIM32_IsActiveFlag_Update(LPTIM32)))
    {
        FL_LPTIM32_ClearFlag_Update(LPTIM32);
        timeWakeup = true;
    }
}
