#include "sleep.h"
#include "main.h"
#include "user_init.h"

bool isWakeup = false;

void SleepInit(void)
{
//    FL_GPIO_InitTypeDef gpioInitStruct = {0};      

//    gpioInitStruct.pin        = FL_GPIO_PIN_12;
//    gpioInitStruct.mode       = FL_GPIO_MODE_INPUT;
//    gpioInitStruct.outputType = FL_GPIO_OUTPUT_PUSHPULL;
//    gpioInitStruct.pull       = DISABLE;
//    gpioInitStruct.remapPin   = DISABLE;	
//    FL_GPIO_Init(GPIOB, &gpioInitStruct);

//    FL_GPIO_SetWakeupEdge(GPIO, FL_GPIO_WAKEUP_3, FL_GPIO_WAKEUP_TRIGGER_RISING);
//    FL_GPIO_EnableWakeup(GPIO, FL_GPIO_WAKEUP_3);
}

// Sleep
void Sleep(void)
{
    FL_PMU_SleepInitTypeDef sleepInitStruct;
     
    FL_RMU_PDR_Enable(RMU);                 // PDR
    FL_RMU_BORPowerDown_Disable(RMU);       // رBOR(2uA)
    FL_VREF_Disable(VREF);                  // رVREF1p2(2uA)
    
    sleepInitStruct.deepSleep = FL_PMU_SLEEP_MODE_NORMAL;
    sleepInitStruct.LDOLowPowerMode = FL_PMU_LDO_LPM_ENABLE;
    sleepInitStruct.wakeupFrequency = FL_PMU_RCHF_WAKEUP_FREQ_8MHZ;
    sleepInitStruct.wakeupDelay = FL_PMU_WAKEUP_DELAY_8US;
    sleepInitStruct.coreVoltageScaling = DISABLE; 
    FL_PMU_Sleep_Init(PMU, &sleepInitStruct);
    
    // 
    FL_PMU_SetLowPowerMode(PMU, FL_PMU_POWER_MODE_SLEEP_OR_DEEPSLEEP);
    __WFI();
    
    // VREF1P2ȴ
    FL_VREF_Enable(VREF); 
    DelayMs(2);
}

//DeepSleep
void DeepSleep(void)
{
    FL_PMU_SleepInitTypeDef sleepInitStruct;
    
    FL_RMU_PDR_Enable(RMU);                 // PDR
    FL_RMU_BORPowerDown_Disable(RMU);       // رBOR(2uA)
    FL_VREF_Disable(VREF);                  // رVREF1p2(2uA)
    
    sleepInitStruct.deepSleep = FL_PMU_SLEEP_MODE_DEEP;
    sleepInitStruct.LDOLowPowerMode = FL_PMU_LDO_LPM_DISABLE;
    sleepInitStruct.wakeupFrequency = FL_PMU_RCHF_WAKEUP_FREQ_8MHZ;
    sleepInitStruct.wakeupDelay = FL_PMU_WAKEUP_DELAY_8US;
    sleepInitStruct.coreVoltageScaling = DISABLE; 
    FL_PMU_Sleep_Init(PMU, &sleepInitStruct);
    
    // 
    FL_PMU_SetLowPowerMode(PMU, FL_PMU_POWER_MODE_SLEEP_OR_DEEPSLEEP);
    __WFI();
    
    // VREF1P2ȴ
    FL_VREF_Enable(VREF);   
    DelayMs(2);
}

void NMI_Handler(void)
{
    if (FL_PMU_IsActiveFlag_WakeupPIN(PMU, FL_GPIO_WAKEUP_3))
    {
        FL_PMU_ClearFlag_WakeupPIN(PMU, FL_GPIO_WAKEUP_3);
        isWakeup = true;
    }
}
