#include "user_init.h"

void ClockInit(uint32_t clock)
{
    FL_FLASH_SetReadWait(FLASH, FL_FLASH_READ_WAIT_2CYCLE);
    
    switch (clock)
    {
        case SYSCLK_RCHF_PLL64M:
            // ʼʱӣPLL64MƵ
            FL_RCC_PLL_SetClockSource(FL_RCC_PLL_CLK_SOURCE_RCHF);
            FL_RCC_PLL_SetPrescaler(FL_RCC_PLL_PSC_DIV8);
            FL_RCC_PLL_WriteMultiplier(64 - 1);
            FL_RCC_PLL_SetOutputMultiplier(FL_RCC_PLL_OUTPUT_X1);
            FL_RCC_PLL_Enable();
            while (!FL_RCC_IsActiveFlag_PLLReady());

            FL_RCC_SetSystemClockSource(FL_RCC_SYSTEM_CLK_SOURCE_PLL);
            break;
        
        default:
            break;
    }
}

void FoutInit(void)
{
    FL_GPIO_InitTypeDef gpioInitStruct = {0};
    
    gpioInitStruct.pin = FL_GPIO_PIN_11;
    gpioInitStruct.mode = FL_GPIO_MODE_DIGITAL;
    gpioInitStruct.outputType = FL_GPIO_OUTPUT_PUSHPULL;
    gpioInitStruct.pull = DISABLE;
    FL_GPIO_Init(GPIOD, &gpioInitStruct);
    
    FL_GPIO_SetFOUT0(GPIO, FL_GPIO_FOUT0_SELECT_AHBCLK_DIV64);
}

static void SystickInit(void)
{
    SysTick->CTRL |= SysTick_CTRL_CLKSOURCE_Msk;
    SysTick->CTRL |= SysTick_CTRL_ENABLE_Msk;
}

void UserInit(void)
{
    SystickInit();
}

void DelayUs(uint32_t count)
{
    count = (uint64_t)FL_RCC_GetSystemClockFreq() * count / 1000000;
    count = count > 16777216 ? 16777216 : count;
    
    SysTick->LOAD = count - 1;
    SysTick->VAL = 0;
    while (!((SysTick->CTRL >> 16) & 0x1));
}

void DelayMs(uint32_t count)
{
    while (count--)
    {
        DelayUs(1000);
    }
}
